#include <gtk/gtk.h>

GtkWidget *entry;

void setVisible(GtkWidget *widget,
				gpointer data)
{
	gtk_entry_set_visibility(GTK_ENTRY(entry),gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(widget)));
}

void destroy( GtkWidget *widget,
              gpointer   data )
{
    gtk_main_quit ();
}

int main( int   argc,
          char *argv[] )
{
    GtkWidget *window;
	GtkWidget *vbox;
	GtkWidget *check_button;

    gtk_init (&argc, &argv);
    
	//window
    window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
    g_signal_connect (G_OBJECT (window), "destroy",
		      G_CALLBACK (destroy), NULL);
    gtk_container_set_border_width (GTK_CONTAINER (window), 10);

	//vbox
	vbox = gtk_vbox_new (FALSE, 0);

    gtk_container_add (GTK_CONTAINER (window), vbox);
	gtk_widget_show(vbox);
    
	//entry
	entry=gtk_entry_new();
	gtk_entry_set_text(GTK_ENTRY(entry),"helloworld");
	gtk_entry_set_max_length (GTK_ENTRY (entry), 50);	

	//check box
	check_button=gtk_check_button_new_with_label("Visibility");
	gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON (check_button),TRUE);

	 g_signal_connect(G_OBJECT (check_button), "toggled",
			      G_CALLBACK (setVisible),NULL);

	 gtk_box_pack_start (GTK_BOX (vbox), check_button, TRUE, TRUE, 0);
	 gtk_box_pack_start (GTK_BOX (vbox), entry, TRUE, TRUE, 0);

	 gtk_widget_show (check_button);
	 gtk_widget_show (entry);
	 gtk_widget_show (window);
    
    gtk_main ();
    
    return 0;
}
